function init()
	RegisterTool("plasmarifle", "Plasma Rifle", "MOD/vox/plasma.vox")
	SetBool("game.tool.plasmarifle.enabled", true)

	SetFloat("game.tool.plasmarifle.ammo", 1001)

    damage = 0.5
    animrec = 0
    cooldown = 0
    recoil = 0
	
	plasmaSnd = LoadSound("MOD/snd/plasma.ogg")
end

--Return a random vector of desired length
function rndVec(length)
	local v = VecNormalize(Vec(math.random(100,100), math.random(100,100), math.random(100,100)))
	return VecScale(v, length)	
end

function tick(dt)
	if GetString("game.player.tool") == "plasmarifle" and GetBool("game.player.canusetool") then
		anim()

		if InputPressed("lmb") and GetFloat("game.tool.plasmarifle.ammo") > 0 then 
			local t = GetCameraTransform()
			local p = TransformToParentPoint(t, Vec(0, 0, -2))
			local d = VecAdd(TransformToParentVec(t, Vec(0,0,-1)), Vec(0, 0, 0))
			if cooldown == 0 then
				PlaySound(plasmaSnd)
				Shoot(p, d)
				giveanim = true
	            cooldown = 15
				SetFloat("game.tool.plasmarifle.ammo", math.max(0, GetFloat("game.tool.plasmarifle.ammo")-1))
				local light = TransformToParentPoint(t, Vec(0.65, -0.5, -3.5))
				PointLight(light, 0, 1, 1, 1)
			end
		end
		if GetToolBody() ~= 0 then
			local t = Transform()
			t.pos = Vec(0.3, -0.7, -0.7 + (recoil / 80))
			t.rot = QuatEuler(0 + recoil / 2, 0, 0)
			SetToolTransform(t)
		end
	end
end

function anim()
    if not giveanim then
        if animrec ~= 0 and cooldown ~= 0 then
            animrec = animrec - 5
            cooldown = cooldown - 5
        end
    end

    if giveanim then
        if animrec ~= 15 then
            animrec = animrec + 5
        else
            giveanim = false
        end
    end

    recoil = math.max(0, animrec)
end